## getdp 3.5.0+dfsg1

=== CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2022 P. Dular and C. Geuzaine, University of Liege
#
# See the LICENSE.txt file for license information. Please report all
# issues on https://gitlab.onelab.info/getdp/getdp/issues.

cmake_minimum_required(VERSION 3.3 FATAL_ERROR)

# if CMAKE_BUILD_TYPE is specified use it; otherwise set the default
# build type to "RelWithDebInfo" ("-O2 -g" with gcc) prior to calling
# project()
if(DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Choose build type")
else()
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose build type")
endif()

# this variable controls the default value of the options which are normally set
# to ON (useful if you want to configure a minimal version of GetDP: e.g. "cmake
# -DDEFAULT=0 -DENABLE_PETSC=1")
set(DEFAULT ON CACHE INTERNAL "Default value for enabled-by-default options")

macro(opt OPTION HELP VALUE)
  option(ENABLE_${OPTION} ${HELP} ${VALUE})
  set(OPT_TEXI "${OPT_TEXI}\n@item ENABLE_${OPTION}\n${HELP} (default: ${VALUE})")
endmacro()

opt(ARPACK "Enable Arpack eigensolver (requires Fortran)" ${DEFAULT})
opt(BLAS_LAPACK "Enable BLAS/Lapack for linear algebra (e.g. for Arpack)" ${DEFAULT})
opt(BUILD_LIB "Enable 'lib' target for building static GetDP library" OFF)
opt(BUILD_SHARED "Enable 'shared' target for building shared GetDP library" OFF)
opt(BUILD_DYNAMIC "Enable dynamic GetDP executable (linked with shared lib)" OFF)
opt(BUILD_ANDROID "Enable Android NDK library target (experimental)" OFF)
opt(BUILD_IOS "Enable iOS (ARM) library target (experimental)" OFF)
opt(FORTRAN "Enable Fortran (needed for Arpack/Sparskit/Zitsol & Bessel)" ${DEFAULT})
opt(GMSH "Enable Gmsh functions (for field interpolation)" ${DEFAULT})
opt(GSL "Enable GSL functions (for some built-in functions)" ${DEFAULT})
opt(KERNEL "Enable kernel (required for actual computations)" ON)
opt(MMA "Enable MMA optimizer" ${DEFAULT})
opt(MPI "Enable MPI parallelization (with PETSc/SLEPc)" OFF)
opt(MULTIHARMONIC "Enable multi-harmonic support" OFF)
opt(NR "Enable NR functions (if GSL is unavailable)" ${DEFAULT})
opt(NX "Enable proprietary NX extension" OFF)
opt(OCTAVE "Enable Octave functions" OFF)
opt(OPENMP "Enable OpenMP parallelization of some functions (experimental)" OFF)
opt(PETSC "Enable PETSc linear solver" ${DEFAULT})
opt(PRIVATE_API "Enable private API" OFF)
opt(PYTHON "Enable Python functions" ${DEFAULT})
opt(SLEPC "Enable SLEPc eigensolver" ${DEFAULT})
opt(SMALLFEM "Enable experimental SmallFem assembler" OFF)
opt(SPARSKIT "Enable Sparskit solver instead of PETSc (requires Fortran)" ${DEFAULT})
opt(SYSTEM_CONTRIB "Use system versions of contrib libraries, when possible" OFF)
opt(PEWE "Enable PeWe exact solutions (requires Fortran)" ${DEFAULT})
opt(WRAP_PYTHON "Build Python wrappers" OFF)
opt(ZITSOL "Enable Zitsol solvers (requires PETSc and Fortran)" OFF)

if(ENABLE_FORTRAN)
  project(getdp CXX C Fortran)
else()
  project(getdp CXX C)
endif()

# require C++11 and request C99
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_C_STANDARD 99)

set(GETDP_MAJOR_VERSION 3)
set(GETDP_MINOR_VERSION 5)
set(GETDP_PATCH_VERSION 0)
set(GETDP_EXTRA_VERSION "")
set(GETDP_EXTRA_VERSION_TEXI "${GETDP_EXTRA_VERSION}")

if(NOT GETDP_RELEASE)
  find_package(Git)
  if(GIT_FOUND)
    execute_process(COMMAND ${GIT_EXECUTABLE} log -1 --format=%h
                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR} ERROR_QUIET
                    OUTPUT_VARIABLE GIT_COMMIT_HASH
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
  endif()
  if(GIT_COMMIT_HASH)
    set(GETDP_EXTRA_VERSION "${GETDP_EXTRA_VERSION}-git-${GIT_COMMIT_HASH}")
  endif()
  set(GETDP_EXTRA_VERSION_TEXI "${GETDP_EXTRA_VERSION_TEXI} (development version)")
endif()

set(GETDP_VERSION "${GETDP_MAJOR_VERSION}.${GETDP_MINOR_VERSION}")
set(GETDP_VERSION "${GETDP_VERSION}.${GETDP_PATCH_VERSION}${GETDP_EXTRA_VERSION}")
set(GETDP_SHORT_LICENSE "GNU General Public License")

set(GETDP_API src/kernel/getdp.h)

if(ENABLE_PRIVATE_API)
  set(GETDP_PRIVATE_API src/kernel/getdp.h
    ${CMAKE_CURRENT_BINARY_DIR}/src/common/GetDPConfig.h
    ${CMAKE_CURRENT_BINARY_DIR}/src/common/GetDPVersion.h)
endif()

if(${CMAKE_MAJOR_VERSION} GREATER 2)
  string(TIMESTAMP DATE "%Y%m%d")
else()
  execute_process(COMMAND date "+%Y%m%d" OUTPUT_VARIABLE DATE
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()

if(NOT DATE)
  set(DATE "unknown")
endif()
set(GETDP_DATE "${DATE}")

if(NOT GETDP_HOST)
  execute_process(COMMAND hostname OUTPUT_VARIABLE HOST
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
  if(NOT HOST)
    set(HOST "unknown")
  endif()
  set(GETDP_HOST "${HOST}")
endif()

if(NOT GETDP_PACKAGER)
  execute_process(COMMAND whoami OUTPUT_VARIABLE PACKAGER
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
  if(NOT PACKAGER)
    set(PACKAGER "unknown")
  endif()
  string(REPLACE "\\" " " PACKAGER ${PACKAGER})
  set(GETDP_PACKAGER "${PACKAGER}")
endif()

if(APPLE)
  set(GETDP_OS "MacOSX")
elseif(CYGWIN)
  # detect if we use the MinGW compilers on Cygwin - if we do, handle the build
  # as a pure Windows build
  if(CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR
     CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpmachine
                    OUTPUT_VARIABLE CXX_COMPILER_MACHINE
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(CXX_COMPILER_MACHINE MATCHES "mingw")
      set(GETDP_OS "Windows")
      set(WIN32 1)
      add_definitions(-DWIN32)
    endif()
  endif()
else()
  set(GETDP_OS "${CMAKE_SYSTEM_NAME}")
endif()

include(CheckTypeSize)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCXXCompilerFlag)
include(CheckFortranCompilerFlag)

macro(set_config_option VARNAME STRING)
  set(${VARNAME} TRUE)
  list(APPEND CONFIG_OPTIONS ${STRING})
  message(STATUS "Found " ${STRING})
endmacro()

# check if the machine is 64 bits (this is more reliable than using
# CMAKE_SIZEOF_VOID_P, which does not seem to work e.g. on some Suse
# machines)
check_type_size("void*" SIZEOF_VOID_P)
if(SIZEOF_VOID_P EQUAL 8)
  set_config_option(HAVE_64BIT_SIZE_T "64Bit")
endif()

# append 32/64 to the build name on Linux and Windows
if(NOT APPLE)
  if(HAVE_64BIT_SIZE_T)
    set(GETDP_OS "${GETDP_OS}64")
  else()
    set(GETDP_OS "${GETDP_OS}32")
  endif()
endif()

if(ENABLE_WRAP_PYTHON AND NOT ENABLE_BUILD_SHARED)
  set(ENABLE_BUILD_DYNAMIC ON)
endif()

if(MSVC)
  if(ENABLE_MSVC_STATIC_RUNTIME)
    foreach(VAR
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
      if(${VAR} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${VAR} "${${VAR}}")
      endif()
    endforeach()
  endif()
endif()

if(ENABLE_OPENMP)
  find_package(OpenMP)
  if(OPENMP_FOUND)
    set_config_option(HAVE_OPENMP "OpenMP")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${OpenMP_Fortran_FLAGS}")
  endif()
endif()

macro(append_getdp_src DIRNAME FILES)
  foreach(FILE ${FILES})
    list(APPEND LIST ${DIRNAME}/${FILE})
  endforeach()
  set(GETDP_SRC ${GETDP_SRC};${LIST} PARENT_SCOPE)
  set(GETDP_DIRS ${GETDP_DIRS};${DIRNAME} PARENT_SCOPE)
endmacro()

macro(find_all_libraries VARNAME LISTNAME PATH SUFFIX)
  set(${VARNAME})
  list(LENGTH ${LISTNAME} NUM_LIST)
  foreach(LIB ${${LISTNAME}})
    if("${PATH}" STREQUAL "")
      find_library(FOUND_LIB ${LIB} PATH_SUFFIXES ${SUFFIX})
    else()
      find_library(FOUND_LIB ${LIB} PATHS ${PATH} NO_DEFAULT_PATH)
    endif()
    if(FOUND_LIB)
      list(APPEND ${VARNAME} ${FOUND_LIB})
    endif()
    unset(FOUND_LIB CACHE)
  endforeach()
  list(LENGTH ${VARNAME} NUM_FOUND_LIBRARIES)
  if(NUM_FOUND_LIBRARIES LESS NUM_LIST)
    set(${VARNAME})
  endif()
endmacro()

macro(set_compile_flags LISTNAME FLAGS)
  foreach(FILE ${${LISTNAME}})
    get_source_file_property(PROP ${FILE} COMPILE_FLAGS)
    if(PROP)
      set_source_files_properties(${FILE} PROPERTIES COMPILE_FLAGS "${PROP} ${FLAGS}")
    else()
      set_source_files_properties(${FILE} PROPERTIES COMPILE_FLAGS "${FLAGS}")
    endif()
  endforeach()
endmacro()

if(ENABLE_BLAS_LAPACK)
  if(BLAS_LAPACK_LIBRARIES)
    # use libs as specified in the BLAS_LAPACK_LIBRARIES variable
    set_config_option(HAVE_BLAS "Blas[custom]")
    set_config_option(HAVE_LAPACK "Lapack[custom]")
    set(LAPACK_LIBRARIES ${BLAS_LAPACK_LIBRARIES})
  else()
    if(MSVC)
      # on Windows with Visual C++ try really hard to find blas/lapack *without*
      # requiring a Fortran compiler: 1) try to find the Intel MKL libs using
      # the standard search path; if not found 2) try to get the reference
      # blas/lapack libs (useful for users with no Fortran compiler and no MKL
      # license, who can just download our precompiled "gmsh-dep" package)
      if(HAVE_64BIT_SIZE_T)
        set(MKL_PATH em64t/lib)
        set(MKL_LIBS_REQUIRED libguide40 mkl_intel_lp64 mkl_intel_thread mkl_core)
      else()
        set(MKL_PATH ia32/lib)
        set(MKL_LIBS_REQUIRED libguide40 mkl_intel_c mkl_intel_thread mkl_core)
      endif()
      find_all_libraries(LAPACK_LIBRARIES MKL_LIBS_REQUIRED "" ${MKL_PATH})
      if(LAPACK_LIBRARIES)
        set_config_option(HAVE_BLAS "Blas[mkl]")
        set_config_option(HAVE_LAPACK "Lapack[mkl]")
      else()
        set(REFLAPACK_LIBS_REQUIRED lapack blas g2c gcc)
        find_all_libraries(LAPACK_LIBRARIES REFLAPACK_LIBS_REQUIRED "" "")
        if(LAPACK_LIBRARIES)
          set_config_option(HAVE_BLAS "Blas[ref]")
          set_config_option(HAVE_LAPACK "Lapack[ref]")
        endif()
      endif()
    elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
      # on Linux try to find the Intel MKL without a Fortran compiler
      if(HAVE_64BIT_SIZE_T)
        set(MKL_PATH lib/em64t)
      else()
        set(MKL_PATH lib/32)
      endif()
      set(MKL_LIBS_REQUIRED mkl_gf_lp64 iomp5 mkl_gnu_thread mkl_core guide pthread)
      find_all_libraries(LAPACK_LIBRARIES MKL_LIBS_REQUIRED "" ${MKL_PATH})
      if(NOT LAPACK_LIBRARIES)
        # match lapack 9.0 on 64bit
        set(MKL_LIBS_REQUIRED mkl_lapack mkl_em64t guide)
        find_all_libraries(LAPACK_LIBRARIES MKL_LIBS_REQUIRED "" ${MKL_PATH})
      endif()
      if(LAPACK_LIBRARIES)
        set_config_option(HAVE_BLAS "Blas[mkl]")
        set_config_option(HAVE_LAPACK "Lapack[mkl]")
      else()
        # on Linux also try to find ATLAS without a Fortran compiler, because
        # cmake ships with a buggy FindBLAS e.g. on Ubuntu Lucid Lynx
        set(ATLAS_LIBS_REQUIRED lapack f77blas cblas atlas)
        find_all_libraries(LAPACK_LIBRARIES ATLAS_LIBS_REQUIRED "" "")
        if(LAPACK_LIBRARIES)
          set_config_option(HAVE_BLAS "Blas[atlas]")
          set_config_option(HAVE_LAPACK "Lapack[atlas]")
        else()
          # try with generic names
          set(GENERIC_LIBS_REQUIRED lapack blas pthread)
          find_all_libraries(LAPACK_LIBRARIES GENERIC_LIBS_REQUIRED "" "")
          if(LAPACK_LIBRARIES)
            set_config_option(HAVE_BLAS "Blas")
            set_config_option(HAVE_LAPACK "Lapack")
            find_library(GFORTRAN_LIB gfortran)
            if(GFORTRAN_LIB)
              list(APPEND LAPACK_LIBRARIES ${GFORTRAN_LIB})
            endif()
          endif()
        endif()
      endif()
    elseif(${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
      # on SunOS we know blas and lapack are available in sunperf
      set(LAPACK_LIBRARIES -library=sunperf)
      set_config_option(HAVE_BLAS "Blas[sunperf]")
      set_config_option(HAVE_LAPACK "Lapack[sunperf]")
    elseif(APPLE)
      # on Mac we also know that blas and lapack are available
      set(LAPACK_LIBRARIES "-llapack -lblas")
      set_config_option(HAVE_BLAS "Blas[veclib]")

=== contrib/Sparskit/CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2022 P. Dular and C. Geuzaine, University of Liege
#
# See the LICENSE.txt file for license information. Please report all
# issues on https://gitlab.onelab.info/getdp/getdp/issues.

set(SRC
  Sparskit.cpp
  blas1.f
  blassm.f
  cmkreord.f
  flu.f
  formats.f
  inout.f
  iters.f
  matvec.f
  reordering.f
  unary.f
  ilut.F
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_getdp_src(contrib/Sparskit "${SRC};${HDR}")

=== src/common/CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2022 P. Dular and C. Geuzaine, University of Liege
#
# See the LICENSE.txt file for license information. Please report all
# issues on https://gitlab.onelab.info/getdp/getdp/issues.

set(SRC
  ListUtils.cpp
    TreeUtils.cpp avl.cpp
    MallocUtils.cpp
    Message.cpp
    OS.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_getdp_src(src/common "${SRC};${HDR}")

=== src/interface/CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2022 P. Dular and C. Geuzaine, University of Liege
#
# See the LICENSE.txt file for license information. Please report all
# issues on https://gitlab.onelab.info/getdp/getdp/issues.

set(SRC
  ProData.cpp
  ProDefine.cpp
  ProParser.yy.cpp
  ProParser.tab.cpp
  MacroManager.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_getdp_src(src/interface "${SRC};${HDR}")

=== src/kernel/CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2022 P. Dular and C. Geuzaine, University of Liege
#
# See the LICENSE.txt file for license information. Please report all
# issues on https://gitlab.onelab.info/getdp/getdp/issues.

set(SRC
  MainKernel.cpp
    Gauss_Point.cpp
      Gauss_Line.cpp
      Gauss_Triangle.cpp Gauss_Quadrangle.cpp
      Gauss_Tetrahedron.cpp Gauss_Hexahedron.cpp
      Gauss_Prism.cpp Gauss_Pyramid.cpp
    GeoData.cpp
      GeoEntity.cpp
      GeoNormal.cpp
      GeoTree.cpp
    DofData.cpp
      LinAlg.cpp LinAlg_PETSC.cpp LinAlg_SPARSKIT.cpp
    SolvingAnalyse.cpp SolvingOperations.cpp
      Cal_SolutionErrorRatio.cpp
      Operation_TimeLoopAdaptive.cpp
      Operation_IterativeLoopN.cpp
      Operation_IterativeLinearSolver.cpp
      Operation_IterativeTimeReduction.cpp
      Operation_Update.cpp Operation_Vector.cpp
      Operation_ChangeOfCoordinates.cpp
      Operation_PostOperation.cpp
      Operation_Debug.cpp
      Operation_Optimizer.cpp
      Operation_Broadcast.cpp
      Treatment_Formulation.cpp
        Get_DofOfElement.cpp
        Get_ConstraintOfElement.cpp
          Get_FunctionValue.cpp
          Get_Geometry.cpp
          Get_ElementSource.cpp
        ExtendedGroup.cpp
        Pre_TermOfFemEquation.cpp
          Generate_Network.cpp
        Cal_GalerkinTermOfFemEquation.cpp
        Cal_SmallFemTermOfFemEquation.cpp
        Cal_GlobalTermOfFemEquation.cpp
          Cal_IntegralQuantity.cpp
          Cal_AnalyticIntegration.cpp
          Cal_AssembleTerm.cpp
          Cal_PostQuantity.cpp
      MovingBand2D.cpp
      EigenSolve.cpp EigenSolve_ARPACK.cpp EigenSolve_SLEPC.cpp
    Pos_FemInterpolation.cpp
    Pos_Formulation.cpp
      Pos_Print.cpp
        Pos_Element.cpp Pos_Format.cpp Pos_Iso.cpp Pos_Search.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_getdp_src(src/kernel "${SRC};${HDR}")

=== src/numeric/CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2022 P. Dular and C. Geuzaine, University of Liege
#
# See the LICENSE.txt file for license information. Please report all
# issues on https://gitlab.onelab.info/getdp/getdp/issues.

set(SRC
  NumericUtils.cpp
  Adapt.cpp
  Legendre.cpp
  Bessel.cpp
)

if(ENABLE_FORTRAN)
  list(APPEND SRC BesselLib.f)
endif(ENABLE_FORTRAN)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_getdp_src(src/numeric "${SRC};${HDR}")

=== debian/changelog ===
getdp (3.5.0+dfsg1-5) unstable; urgency=medium

  * Team upload.

  [ Alexandre Detiste ]
  * [e7e7bbb] remove ancient SVN script

  [ Francesco Ballarin ]
  * [d8fca99] Update Francesco Ballarin's email address
  * [8397653] Trim trailing whitespace in changelog.
  * [8802775] Remove trailing whitespace in debian/copyright (routine-update)
  * [9e89be1] Use secure URI in Homepage field.
  * [7067a72] Avoid explicitly specifying -Wl,--as-needed linker flag.

  [ Adrian Bunk ]
  * Backport upstream fix for FTBFS with CMake 4. Closes: #1112948.

 -- Santiago Vila <sanvila@debian.org>  Mon, 13 Oct 2025 19:50:00 +0200

getdp (3.5.0+dfsg1-4) unstable; urgency=medium

  * Team upload.
  * Fix Team name
  * Standards-Version: 4.7.2

 -- Alexandre Detiste <tchet@debian.org>  Wed, 23 Apr 2025 13:47:39 +0200

getdp (3.5.0+dfsg1-3) unstable; urgency=medium

  * [f59522d] OpenMPI 5.0 changed the name of the environment variable to set the SSH
    agent from
       export OMPI_MCA_plm_rsh_agent=/bin/false
    to
       export PRTE_MCA_plm_ssh_agent=/bin/false
    Use the new variable name in debian/rules.
  * [4b0bf11] Set lower bound >= 1.17 to Build-Depends: mpi-default-dev because the environment
    variable PRTE_MCA_plm_ssh_agent is set at build time in debian/rules

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Wed, 20 Nov 2024 07:23:16 +0000

getdp (3.5.0+dfsg1-2) unstable; urgency=medium

  * [c9f0c0f] Add Francesco Ballarin to uploaders
  * [73104c0] Fix lintian error E: getdp source: duplicate-globbing-patterns Interface/ProParser.tab.hpp (lines 54 59) [debian/copyright]

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 14 Apr 2024 16:58:51 +0000

getdp (3.5.0+dfsg1-1) experimental; urgency=medium

  [ Christophe Trophime ]
  * [9cd3415] fix #927140

  [ Francesco Ballarin ]
  * [791deb1] New upstream version 3.5.0+dfsg1
  * [8251bbf] Drop debian/patches/petsc-dev-5f171b22.patch: upstream now handles switching between PCFactorSetMatSolverPackage and PCFactorSetMatSolverType with a #define
  * [a9f0161] Refresh localise_toplevel_htmldoc.patch
  * [51d021b] Refresh petsc.patch
  * [eef3901] Refresh link_fortran.patch
  * [3c66539] Add libeigen3-dev to build dependencies, because getdp/src/functions/BF_Node.cpp includes gmsh/fullMatrix.h, which in turn includes Eigen/Dense
  * [17a1f7b] New patch add_eigen_include_directories.patch to ensure that system-wide installation of eigen is picked up by cmake
  * [5962679] demos were renamed to examples in upstream commit f448f64013ae928419262f27dd2cd81fee35c631
  * [d3012f4] Bump debhelper-compat to 13
  * [6894390] Enable salsa CI

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 14 Apr 2024 08:24:01 +0000

=== debian/control ===
Source: getdp
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>,
           Francesco Ballarin <ballarin@debian.org>
Section: math
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               gfortran,
               libarpack2-dev,
               libgsl-dev,
               libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
               liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
               libeigen3-dev,
               libgmsh-private-headers-dev,
               mpi-default-dev (>= 1.17),
               petsc-dev,
               python3-dev,
               slepc-dev,
               swig,
               texlive,
               texlive-plain-generic,
               texinfo
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/science-team/getdp
Vcs-Git: https://salsa.debian.org/science-team/getdp.git
Homepage: https://www.geuz.org/getdp

Package: getdp
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: general environment for the treatment of discrete problems
 GetDP is a general finite element solver using mixed elements to
 discretize de Rham-type complexes in one, two and three dimensions.
 .
 The main feature of GetDP is the closeness between the input data
 defining discrete problems (written by the user in ASCII data files)
 and the symbolic mathematical expressions of these problems.
 .
 See GetDP's reference manual for a more thorough overview of GetDP's
 capabilities: http://www.geuz.org/getdp

Package: getdp-sparskit
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: general environment for the treatment of discrete problems
 GetDP is a general finite element solver using mixed elements to
 discretize de Rham-type complexes in one, two and three dimensions.
 .
 The main feature of GetDP is the closeness between the input data
 defining discrete problems (written by the user in ASCII data files)
 and the symbolic mathematical expressions of these problems.
 .
 See GetDP's reference manual for a more thorough overview of GetDP's
 capabilities: http://www.geuz.org/getdp
 .
 Getdp is compiled with SPARSKIT support

=== debian/rules ===
#!/usr/bin/make -f

BUILDDIR_PETSC = $(CURDIR)/debian/build/petsc
BUILDDIR_SPARSKIT = $(CURDIR)/debian/build/sparskit

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic

export PRTE_MCA_plm_ssh_agent=/bin/false                #workaround to start MPI-applications in chroot

%:
	dh $@

GETDP_CONFIGURE_COMMON =    -DENABLE_MPI:BOOL=ON \
			    -DCMAKE_SKIP_RPATH:BOOL=ON \
			    -DBLAS_LAPACK=ON -DBLAS_LAPACK_LIBRARIES="-llapack -lblas"

override_dh_auto_configure:
	dh_auto_configure --builddirectory=$(BUILDDIR_PETSC) -O--parallel    -- $(GETDP_CONFIGURE_COMMON) -DENABLE_PETSC=1 -DENABLE_SPARSKIT=0
	dh_auto_configure --builddirectory=$(BUILDDIR_SPARSKIT) -O--parallel -- $(GETDP_CONFIGURE_COMMON) -DENABLE_PETSC=0 -DENABLE_SPARSKIT=1
	sed -i 's/-lpthread/-lgfortran -lpthread/' debian/build/*/CMakeFiles/getdp.dir/link.txt

override_dh_auto_build:
	dh_auto_build -O--parallel --builddirectory=$(BUILDDIR_PETSC)
	dh_auto_build -O--parallel --builddirectory=$(BUILDDIR_SPARSKIT)
	mv $(BUILDDIR_SPARSKIT)/getdp $(BUILDDIR_SPARSKIT)/getdp-sparskit
	cd debian/build/petsc && make doc

override_dh_auto_install:
	dh_auto_install -O--parallel --builddirectory=$(BUILDDIR_PETSC)
	tar xzf debian/build/petsc/getdp*-doc.tgz -C debian/tmp/usr/share/doc/getdp/
	sed "s|image src=\"|image src=\"/usr/share/doc/getdp/html/|" -i debian/tmp/usr/share/doc/getdp/doc/texinfo/getdp.info
	sed "s|href=\"http://getdp.info/getdp.css|href=\"getdp.css|" -i debian/tmp/usr/share/doc/getdp/doc/texinfo/getdp.html

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR_PETSC) $(BUILDDIR_SPARSKIT)

=== debian/watch ===
version=3
opts=repacksuffix=+dfsg1,uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/,dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$// \
http://www.geuz.org/getdp/src/ getdp-(\d\S*)-source\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
